#include <iostream.h>
#include <stdlib.h>
#include <math.h>
#include "primitives.h"
class nodule
	{
	// This header file serves to provide the state variables for all
	// nodes and links in the simulator. It also provides the death and
	/// recovery function calls to simulate node failure and recovery.
 
	public:
	float deathtime;
	float phoenix;
	float delay;

	int churninga,churna100thou;
	int churna10bill;	
	char churnabig;
	char deadtxmission;	
	short mtbf;  //mean time between failures in seconds thru 33000
	short mtbr;  //mean time between resurrections in seconds	
	char dead;
	short updatnde;
	char waitonnode;
	char reaperrand;

	double length;
	double orilength;      // original value of 1-hop matrix

	// dummy constructor
	nodule ()
		{};
	
	// useful constructor: sets necessary initialization values
	setvalues (double i, short perflag, int infinit,int noedges,short node)
		{
		// for tallying how much churn an individual node undergoes
		deadtxmission=-1;
		length=i;
		orilength=length;
		churninga=0;
		churna100thou=0;
		churna10bill=0;
		churnabig=0; 

		// NEXT HOP INITIALIZATION:
		updatnde=-1;
		
		// ****************************************
		// WANT TO DEFINE ONE SET OF MTBF AND MTBR
		// THE VALUES OF MTBF AND MTBR DO NOT
		// REPRESENT THE ACTUAL MEAN-TIMES BETWEEN FAILURE
		// AND RECOVERY, BUT ARE THE MAX VALUE POSSIBLE.
		// THE ACTUAL MTBF AND MTBR WOULD BE HALF THE ASSIGNED
		// VALUE BELOW.
		// --ONE SET FOR LINKS, and ONE FOR NODES
		       if (node)
			{
			// NODE FAILURE & RECOVERY TIME
			mtbf=1000;
			mtbr=1000;
			}
		      else
			{
			// LINK FAILURE & RECOVERY TIME
			mtbf=1000;
			mtbr=1000;
			}
		
		// compute this node/link's time to drop
		// and recover
			deathtime=(rand())%int(mtbf)+1;
			phoenix=(rand())%int(mtbr)+1;	
		// ****************************************

		// if set to 1, this will indicate that nodes and links
		// cannot drop based on the mtbf, it is desired to cause
		// manual drops.
		reaperrand=perflag;
		// if link must wait for a node to come back up before being
		// able to update, waitonnode will be set to 1
		waitonnode=0;
		return(0);
		}

// below function serves to cause nodes to die or recover based on a
// MEAN-TIME BETWEEN FAILURES set time. Needs to be passed
// the current simulation wall-clock time to determine
// node death and/or resurrection

	void deadfunction(int upordown,float timeadd,short node)
		{
        if ((reaperrand==0)&&(!waitonnode))
		    {
		if ((upordown==1)&&(dead==0)&&((length!=0)||(node)))
			{
			length=infinity;
			dead=1;
			// Need to adjust time to revive
		        // And for next death-time 
			phoenix+=deathtime;
			deathtime=deathtime+phoenix;
			}
		else if ((upordown==0))
			 //(clocktime>=phoenix)
			// Use timeadd to correct MTBF when coming up
			// used for links associated with a node kill
			{
			length=orilength;
			dead=0;
			// Adjust deathtime
			//deathtime=clocktime+deathtime;
			deathtime+=phoenix;
			phoenix=deathtime+phoenix;
			if (timeadd!=-1)
				{
				deathtime+=timeadd;
				phoenix+=timeadd;
				}
			}
		else if ((upordown==3))
			{
			// there was a premature attempted recovery. 
			// should adjust
			// recovery time.
			phoenix+=deathtime;
			}
		     }
		}

	void churn(int x)
        {
	// keeps track of total churn for individual nodes and links
        if (x>0)
        {
        churninga++;
        if (churninga==100000)
                {
                churninga=0;
                churna100thou++;
                        if (churna100thou==100000)
                                {
                                churna100thou=0;
                                churna10bill++;
                                        if (churna10bill==1000000)
                                                {
                                                 churna10bill=0;
                                                 churnabig++;
                                                }
                                }
                }
        }
        else
        {
        churninga--;
        if (churninga<0)
                {
                churninga=0;
                churna100thou--;
                        if (churna100thou<0)
                                {
                                churna100thou=0;
                                churna10bill--;
                                        if (churna10bill<0)
                                                {
                                                churna10bill=0;
                                                churnabig--;
                                                        if (churnabig<0)
                                                                churnabig=0;
                                                }
                                }
                }
        }
        }
			

	void sink(int up)
		{
		// necessary function to reset or destroy nodes and links
		// during recovery or failure stages
		if ((length!=infinity)&&(up==0))
			{
			length=infinity;
			dead=1;
			}
		else if (up==1)
			{
			length=orilength;
			updatnde=-1;
			dead=0;
			}
		}
	
	void update(int l)
		{
		// specialized sink function for manual node kill
		dead=l;
		}
	};

	
	
		
